clear, clc, mode(0), close(winsid()) 
////Vícekroková predikce s regresním modelem $y_t=b_0u_t+a_1y_{t-1}+b_1u_{t-1}+a_2y_{t-2}+b_2u_{t-2}+k+e_t$ a známými parametry

theta=[1 0.4 -0.3 -0.5 0.1 1]; // vektor regresních koeficientů
r=.001;           // rozptyl

nd=100;              //počet dat
np=5;                //počet kroků predikce

u=sign(sin(4*%pi*(1:nd)/nd));        // generujeme řídící vstup


///////////Simulace
y=zeros(1,nd);      //počáteční podmínky
for t=3:nd
    ps=[u(t) y(t-1)  u(t-1) y(t-2)  u(t-2) 1];  //regresní vektor
    y(t)=theta*ps'+sqrt(r)*rand(1,1,'n');//generování výstupu 
end


///Vícekroková predikce výstupu 
for t=3:(nd-np)
    yy(1:(t-1))=y(1:(t-1)); //uložíme stará data
    for i=0:np
        ps=[u(t+i) yy(t+i-1)  u(t+i-1) yy(t+i-2)  u(t+i-2) 1]; //regresní vektor
        yy(t+i)=ps*theta'; //generujeme střední hodnotu predikce 
    end
    yp(t+np)=yy(t+np);         //uložíme vícekrokovou predikci
end

////Výsledky
plot(y,'b-');
plot(yp,'m-');
legend('Simulace','Predikce');
title('Vícekroková předpověď s regresním modelem','fontsize',5);
ylabel('Data','fontsize',5);
xlabel('Čas','fontsize',5);

//Chyba predikce
RMSE = sqrt(mean((y((np+3):nd)' - yp((np+3):nd)).^2));
disp('RMSE: '+string(RMSE)) // root-mean-square error (RMSE)
